
class StreamToIterator[T] (s:Stream[T]) extends Iterator[T] {

  // store the current stream, 
  // update whenever asked for an element

  private var current:Stream[T] = s

  def hasNext:Boolean = current.hasElement()

  def next ():T = 
    if (current.hasElement()) {
      val result = current.head()
      current = current.tail()
      result
    } else {
      throw new RuntimeException("StreamToIterator.next()")
    }
    
}
